{
 "cells": [
  {
   "cell_type": "markdown",
   "id": "154f8cfe-e0e9-4f17-ae45-879f5301ad23",
   "metadata": {},
   "source": [
    "如果刚打开，请先打开一个[登录链接](https://mysunlife.sunlife.com.hk/SunOffice/),然后点一下登入"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "id": "3d49a45a-847c-4e72-91d5-1141f2ae4f26",
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Log in by hand\n"
     ]
    }
   ],
   "source": [
    "#运行下方代码，自动打开浏览器并登录，登录后请选择你要的课程，点击启动后再运行后面代码\n",
    "from selenium import webdriver\n",
    "import time,re\n",
    "import datetime\n",
    "from selenium.webdriver.common.action_chains import ActionChains\n",
    "from selenium.webdriver.common.by import By\n",
    "from selenium.webdriver.support.ui import WebDriverWait\n",
    "from selenium.webdriver.support import expected_conditions as EC\n",
    "\n",
    "def has(a_list):\n",
    "    '''判断一个list是否为空，返回True/False'''\n",
    "    if len(a_list)==0:\n",
    "        return False\n",
    "    else:\n",
    "        return True\n",
    "\n",
    "class Answers():\n",
    "    '''一次测验某一页的答案'''\n",
    "    def __init__(self):\n",
    "        '''{'ans_str':False/True/None}'''\n",
    "        #初始化所有选项为None\n",
    "        self.answers={}\n",
    "        choices=self.get_choice()\n",
    "        for ans_str, _ in choices.items():\n",
    "            self.answers[ans_str]=None\n",
    "\n",
    "    def get_choice(self):\n",
    "        '''返回带有文字对应input_element的字典'''\n",
    "        # 定位所有 class 为 \"choice-view\" 的 div 元素\n",
    "        choice_views = driver.find_elements_by_class_name('choice-view')\n",
    "        \n",
    "        # 创建一个空字典来保存文本和对应的 input 元素\n",
    "        choices = {}\n",
    "        \n",
    "        # 遍历所有 \"choice-view\" 元素\n",
    "        for choice_view in choice_views:\n",
    "            # 在每个 \"choice-view\" 元素中，定位 class 为 \"choice-view__rich-text-view\" 的 div 元素\n",
    "            rich_text_view = choice_view.find_element_by_class_name('choice-view__rich-text-view')\n",
    "            # 获取这个 div 元素的文本\n",
    "            text = rich_text_view.text\n",
    "            # 在这个 \"choice-view\" 元素中，定位 class 为 \"choice-view__mock-active-element\" 的 input 元素\n",
    "            input_element = choice_view.find_element_by_class_name('choice-view__mock-active-element')\n",
    "            # 将文本和对应的 input 元素保存在字典中\n",
    "            choices[text] = input_element\n",
    "        \n",
    "        # 输出字典\n",
    "        # for text, input_element in choices.items():\n",
    "        #     print('Text:', text)\n",
    "        #     print('Input element:', input_element)\n",
    "        self.cur_choices=choices\n",
    "        return choices\n",
    "    \n",
    "    def select_one_choice(self):\n",
    "        '''选择一个可选择的ans_str'''\n",
    "        for ans_str, info in self.answers.items():\n",
    "            if info==True:\n",
    "                self.one_choice=ans_str\n",
    "                return ans_str\n",
    "            elif info==None:\n",
    "                self.one_choice=ans_str\n",
    "                return ans_str\n",
    "        print('No answer')\n",
    "    \n",
    "    def click_choice(self):\n",
    "        '''由于限制，得这样点击选项'''\n",
    "        input_element=self.cur_choices[self.one_choice]\n",
    "        for i in range(3): #多點幾次\n",
    "            # 创建一个 ActionChains 对象\n",
    "            actions = ActionChains(driver)\n",
    "            \n",
    "            # 将鼠标移动到 input 元素上\n",
    "            actions.move_to_element(input_element).pause(1)\n",
    "            \n",
    "            # 点击 input 元素\n",
    "            actions.click(input_element).pause(1)\n",
    "            \n",
    "            # 执行 ActionChains 中的所有操作\n",
    "            actions.perform()\n",
    "\n",
    "        time.sleep(5)\n",
    "        #点击提交\n",
    "        driver.find_element_by_xpath('//button[div[text()=\"提交\"]]').click()\n",
    "        time.sleep(5)\n",
    "        result=driver.find_element_by_class_name('quiz-feedback-panel__header').text\n",
    "        # driver.find_element_by_xpath('//button[div[text()=\"繼續\"]]').click()\n",
    "        if result==\"錯誤\":\n",
    "            return self.update_answer(self.one_choice, False)\n",
    "        else:\n",
    "            return self.update_answer(self.one_choice, True)\n",
    "\n",
    "    def update_answer(self, ans_str, result):\n",
    "        if result==True: #更新并把其他选项列为False\n",
    "            for ans_stri in self.answers.keys():\n",
    "                if ans_stri==ans_str:\n",
    "                    self.answers[ans_stri]=True\n",
    "                else:\n",
    "                    self.answers[ans_stri]=False\n",
    "        elif result==False: #更新一个选项就可以了\n",
    "            self.answers[ans_str]=False\n",
    "\n",
    "def click_next():\n",
    "    '''这是一个通用的click，点击quiz-control-panel__button的最后一个按钮'''\n",
    "    buttons = driver.find_elements_by_xpath('//div[contains(@class, \"quiz-control-panel__container_right\")]//button[contains(@class, \"quiz-control-panel__button\") and not(contains(@style, \"display: none;\"))]')\n",
    "    if buttons:\n",
    "        buttons[-1].click()\n",
    "\n",
    "def go_test():\n",
    "    '''这个函数要完成测试'''\n",
    "    all_answers={}\n",
    "    finish=False\n",
    "    while not finish:\n",
    "        #1.点击按钮开始测试\n",
    "        if has(driver.find_elements_by_xpath('//button[div[contains(text(), \"開始\")] and not(contains(@style, \"display: none;\"))]')):\n",
    "            driver.find_element_by_xpath('//button[div[contains(text(), \"開始\")] and not(contains(@style, \"display: none;\"))]').click()\n",
    "        elif has(driver.find_elements_by_xpath('//*[text()=\"重試評估\" and not(contains(@style, \"display: none;\"))]')):\n",
    "            driver.find_element_by_xpath('//*[text()=\"重試評估\"]').click()\n",
    "        elif has(driver.find_elements_by_xpath('//*[text()=\"開始測驗\" and not(contains(@style, \"display: none;\"))]')):\n",
    "            driver.find_element_by_xpath('//*[text()=\"開始測驗\"]').click()\n",
    "        else:\n",
    "            print('Unknown page, maybe pass')\n",
    "            break\n",
    "        time.sleep(5)\n",
    "\n",
    "        #2.进入试题界面了\n",
    "        text_temp=driver.find_element_by_class_name('quiz-top-panel__question-score-info').text #例如：問題 1/3\n",
    "        parts = text_temp.split(' ')[1].split('/')\n",
    "        current_question = int(parts[0])  # 当前问题序号\n",
    "        total_questions = int(parts[1])  # 问题总数\n",
    "        \n",
    "        for i in range(total_questions):\n",
    "            text_temp=driver.find_element_by_class_name('quiz-top-panel__question-score-info').text #例如：問題 1/3\n",
    "            parts = text_temp.split(' ')[1].split('/')\n",
    "            current_question = int(parts[0])  # 当前问题序号\n",
    "        \n",
    "            #如果第一次见到选项，则初始化\n",
    "            if current_question not in all_answers.keys():\n",
    "                all_answers[current_question]=Answers() #里面会自动根据当前页面更新选项\n",
    "                \n",
    "            all_answers[current_question].get_choice()\n",
    "            all_answers[current_question].select_one_choice()\n",
    "            all_answers[current_question].click_choice() #会自动得到本题对错并更新答案\n",
    "            time.sleep(5)\n",
    "\n",
    "            #点击继续或者检视结果\n",
    "            click_next()\n",
    "            # if has(driver.find_elements_by_xpath('//button[div[text()=\"繼續\"] and not(contains(@style, \"display: none;\"))]')):\n",
    "            #     driver.find_element_by_xpath('//button[div[text()=\"繼續\"]]').click()\n",
    "            # elif has(driver.find_elements_by_xpath('//button[div[text()=\"檢視結果\"] and not(contains(@style, \"display: none;\"))]')):\n",
    "            #     driver.find_element_by_xpath('//button[div[text()=\"檢視結果\"]]').click()\n",
    "            time.sleep(2)\n",
    "            #有下一页的话说明成功了\n",
    "            if has(driver.find_elements_by_xpath('//button[div[text()=\"下一頁\"] and not(contains(@style, \"display: none;\"))]')):\n",
    "                driver.find_element_by_xpath('//button[div[text()=\"下一頁\"] and not(contains(@style, \"display: none;\"))]').click()\n",
    "                finish=True\n",
    "            time.sleep(5)\n",
    "\n",
    "class button_is_clickable(object):\n",
    "    def __init__(self, locator):\n",
    "        self.locator = locator\n",
    "\n",
    "    def __call__(self, driver):\n",
    "        button = driver.find_element(*self.locator)\n",
    "        class_name = button.get_attribute(\"class\")\n",
    "        if class_name != \"cs-button btn cs-disabled\":\n",
    "            return button\n",
    "        else:\n",
    "            return False\n",
    "\n",
    "def parse_cookie_file(cookie_file):\n",
    "    cookies = []\n",
    "    with open(cookie_file, 'r') as f:\n",
    "        for line in f:\n",
    "            if not re.match(r'^#', line) and line.strip():\n",
    "                line_fields = line.strip().split('\\t')\n",
    "                if len(line_fields) == 7:\n",
    "                    cookies.append({\n",
    "                        'name': line_fields[5],\n",
    "                        'value': line_fields[6],\n",
    "                        'domain': line_fields[0],\n",
    "                        'path': line_fields[2],\n",
    "                        'expiry': int(line_fields[4]) if line_fields[4] != '0' else None,\n",
    "                        'secure': False if line_fields[3] == 'FALSE' else True,\n",
    "                    })\n",
    "    return cookies\n",
    "    \n",
    "#手动登录\n",
    "driver = webdriver.Firefox(executable_path='/snap/bin/firefox.geckodriver')\n",
    "driver.get(r'https://mysunlife.sunlife.com.hk/SunOffice/')\n",
    "\n",
    "\n",
    "\n",
    "wait = WebDriverWait(driver, 30)\n",
    "\n",
    "sign_in_button = wait.until(\n",
    "    EC.element_to_be_clickable((By.CSS_SELECTOR, \".yellow-button.line_height_18.sign-button.button.button-md.button-default.button-default-md.button-full.button-full-md\"))\n",
    ")\n",
    "\n",
    "# 添加cookie刷新\n",
    "cookies = parse_cookie_file('cookies.txt')\n",
    "\n",
    "# 添加cookie\n",
    "for cookie in cookies:\n",
    "    if 'expiry' in cookie:\n",
    "        del cookie['expiry']  # Selenium不支持直接设置'expiry'，将其删除\n",
    "    driver.add_cookie(cookie)\n",
    "\n",
    "# 刷新页面以应用cookie\n",
    "driver.refresh()\n",
    "sign_in_button = wait.until(\n",
    "    EC.element_to_be_clickable((By.CSS_SELECTOR, \".yellow-button.line_height_18.sign-button.button.button-md.button-default.button-default-md.button-full.button-full-md\"))\n",
    ")\n",
    "sign_in_button.click()\n",
    "\n",
    "#等待登录页面\n",
    "username_input = wait.until(\n",
    "    EC.visibility_of_element_located((By.ID, \"okta-signin-username\"))\n",
    ")\n",
    "username_input.send_keys(\"Z0S851\")\n",
    "driver.find_element_by_id(\"okta-signin-password\").send_keys('All131415!')\n",
    "driver.find_element_by_id('okta-signin-submit').click()\n",
    "\n",
    "\n",
    "print('Log in by hand')"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "78df02d4-0954-42e7-b9d7-3991f75723de",
   "metadata": {},
   "source": [
    "# 主程序(选好课程后运行)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "id": "de12d57f-66c3-4f8a-a52c-1b70afdc6fc1",
   "metadata": {
    "scrolled": true
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n",
      "Click next\n"
     ]
    },
    {
     "ename": "TimeoutException",
     "evalue": "Message: \n",
     "output_type": "error",
     "traceback": [
      "\u001b[0;31m---------------------------------------------------------------------------\u001b[0m",
      "\u001b[0;31mTimeoutException\u001b[0m                          Traceback (most recent call last)",
      "Cell \u001b[0;32mIn[2], line 48\u001b[0m\n\u001b[1;32m     46\u001b[0m \u001b[38;5;66;03m#5.是要验证码的课程\u001b[39;00m\n\u001b[1;32m     47\u001b[0m \u001b[38;5;28;01melif\u001b[39;00m has(driver\u001b[38;5;241m.\u001b[39mfind_elements_by_css_selector(\u001b[38;5;124m\"\u001b[39m\u001b[38;5;124m#btn_next_page img.btn-highlight\u001b[39m\u001b[38;5;124m\"\u001b[39m)):\n\u001b[0;32m---> 48\u001b[0m     img \u001b[38;5;241m=\u001b[39m \u001b[43mWebDriverWait\u001b[49m\u001b[43m(\u001b[49m\u001b[43mdriver\u001b[49m\u001b[43m,\u001b[49m\u001b[43m \u001b[49m\u001b[38;5;241;43m200\u001b[39;49m\u001b[43m)\u001b[49m\u001b[38;5;241;43m.\u001b[39;49m\u001b[43muntil\u001b[49m\u001b[43m(\u001b[49m\u001b[43mEC\u001b[49m\u001b[38;5;241;43m.\u001b[39;49m\u001b[43mvisibility_of_element_located\u001b[49m\u001b[43m(\u001b[49m\u001b[43m(\u001b[49m\u001b[43mBy\u001b[49m\u001b[38;5;241;43m.\u001b[39;49m\u001b[43mCSS_SELECTOR\u001b[49m\u001b[43m,\u001b[49m\u001b[43m \u001b[49m\u001b[38;5;124;43m\"\u001b[39;49m\u001b[38;5;124;43m#btn_next_page img.btn-highlight\u001b[39;49m\u001b[38;5;124;43m\"\u001b[39;49m\u001b[43m)\u001b[49m\u001b[43m)\u001b[49m\u001b[43m)\u001b[49m\n\u001b[1;32m     49\u001b[0m     img\u001b[38;5;241m.\u001b[39mclick()\n\u001b[1;32m     50\u001b[0m     \u001b[38;5;28mprint\u001b[39m(\u001b[38;5;124m'\u001b[39m\u001b[38;5;124mClick next\u001b[39m\u001b[38;5;124m'\u001b[39m)\n",
      "File \u001b[0;32m~/miniconda3/envs/selenium/lib/python3.8/site-packages/selenium/webdriver/support/wait.py:80\u001b[0m, in \u001b[0;36mWebDriverWait.until\u001b[0;34m(self, method, message)\u001b[0m\n\u001b[1;32m     78\u001b[0m     \u001b[38;5;28;01mif\u001b[39;00m time\u001b[38;5;241m.\u001b[39mtime() \u001b[38;5;241m>\u001b[39m end_time:\n\u001b[1;32m     79\u001b[0m         \u001b[38;5;28;01mbreak\u001b[39;00m\n\u001b[0;32m---> 80\u001b[0m \u001b[38;5;28;01mraise\u001b[39;00m TimeoutException(message, screen, stacktrace)\n",
      "\u001b[0;31mTimeoutException\u001b[0m: Message: \n"
     ]
    }
   ],
   "source": [
    "# 获取所有窗口的句柄，切换到最后一个\n",
    "window_handles = driver.window_handles\n",
    "driver.switch_to.window(window_handles[-1])\n",
    "driver.switch_to.default_content()\n",
    "iframe = driver.find_element_by_xpath('//iframe[1]')\n",
    "driver.switch_to.frame(iframe)\n",
    "while True:\n",
    "    #1.是有计时器的情况，则等待翻页\n",
    "    if has(driver.find_elements_by_css_selector('.progressbar__label.progressbar__label_type_time')):\n",
    "        # 解析时间字符串\n",
    "        timer=driver.find_element_by_css_selector('.progressbar__label.progressbar__label_type_time').text\n",
    "        current_time_string, total_time_string = timer.split(' / ')\n",
    "        current_time = datetime.datetime.strptime(current_time_string, '%M:%S')\n",
    "        total_time = datetime.datetime.strptime(total_time_string, '%M:%S')\n",
    "        \n",
    "        # 判断是否已经达到总时间\n",
    "        if current_time >= total_time:\n",
    "            # 找到按钮并点击下一页\n",
    "            driver.find_element_by_xpath('//button[@aria-label=\"next slide\"]').click()\n",
    "            print(datetime.datetime.now())\n",
    "        else:\n",
    "            # 计算两个时间相差的秒数\n",
    "            seconds = int((total_time-current_time).total_seconds())+5\n",
    "            print('Wait', seconds)\n",
    "            time.sleep(seconds)\n",
    "    #2.有“开始评估“按钮，则点击进入测评\n",
    "    elif has(driver.find_elements_by_xpath('//button[div[contains(text(), \"開始\")] and not(contains(@style, \"display: none;\"))]')):\n",
    "        print(\"开始做题，如果中途暂停，请手动回到开始评估页面（不用点击），然后重新运行这里的程序\")\n",
    "        go_test()\n",
    "        \n",
    "\n",
    "    #3.有“重新评估“按钮，则点击进入测评\n",
    "    elif has(driver.find_elements_by_xpath('//*[text()=\"重試評估\" and not(contains(@style, \"display: none;\"))]')):\n",
    "        print(\"开始做题，如果中途暂停，请手动回到开始评估页面（不用点击），然后重新运行这里的程序\")\n",
    "        go_test()\n",
    "\n",
    "    #4.是没有显示时间的课程\n",
    "    elif has(driver.find_elements_by_id(\"seek\")):\n",
    "        next_button = WebDriverWait(driver, 180).until(\n",
    "            button_is_clickable((By.ID, \"next\"))\n",
    "        )\n",
    "        # 点击按钮\n",
    "        next_button.click()\n",
    "        print('Click')\n",
    "\n",
    "    #5.是要验证码的课程\n",
    "    elif has(driver.find_elements_by_css_selector(\"#btn_next_page img.btn-highlight\")):\n",
    "        img = WebDriverWait(driver, 200).until(EC.visibility_of_element_located((By.CSS_SELECTOR, \"#btn_next_page img.btn-highlight\")))\n",
    "        img.click()\n",
    "        print('Click next')\n",
    "\n",
    "    else:\n",
    "        print('Unknow page')\n",
    "        break\n",
    "        \n",
    "        "
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "selenium",
   "language": "python",
   "name": "selenium"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.8.18"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 5
}
